from qgis.PyQt.QtWidgets import QDialog
from ..tools.settings import set_setting

class SettingsPanel():
    def __init__(self, dialog: QDialog, plugin) -> None:
        self._plugin = plugin
        self._dialog = dialog

    def setup_panel(self) -> None:
        print("Setup Settings panel")
        self.display_error()
        self._dialog.settings_api_key_line_edit.setText(self._plugin.api_key)
        self._dialog.settings_api_key_line_edit.textChanged.connect(self.api_key_changed)
        self._dialog.settings_text_browser.setOpenExternalLinks(True)

    def make_active_panel(self):
        print('settings make active')
        self.display_error()

    def display_error(self):
        if self._plugin.error_message is None:
            self._dialog.settings_error_label.setVisible(False)
        else:
            self._dialog.settings_error_label.setText(self._plugin.error_message)
            self._dialog.settings_error_label.setVisible(True)

    def api_key_changed(self): 
        self._plugin.api_key = self._dialog.settings_api_key_line_edit.text()
        set_setting("api_key", self._plugin.api_key)
        print("Key saved")